'' IExplorer example

'option explicit
#define FALSE 0
#define TRUE Not FALSE
print"TRUE =";TRUE 


#define UNICODE
#include "disphelper.bi"
#include "rqString.bi"

#define wdReplaceNone  0 
#define wdReplaceOne   1  
#define wdReplaceAll   2 

#define   wdFindStop  0 
#define   wdFindContinue  1 
#define   wdFindAsk  2

'Wrap Optional Variant. 
'Controls what happens if the search begins at a point other than the beginning of the document and the end of the 
'document is reached (or vice versa if Forward is set to False). 
'This argument also controls what happens if there's a selection or range and the search text isn't found in the 
'selection or range. Can be one of the following WdFindWrap constants.
'WdFindWrap can be one of these WdFindWrap constants.

'wdFindAsk After searching the selection or range, Microsoft Word displays a message asking whether to search 
'the remainder of the document.

'wdFindContinue The find operation continues if the beginning or end of the search range is reached.
'wdFindStop The find operation ends if the beginning or end of the search range is reached.


dim  a as integer

'*****************************************
function searcReplaceinWord( byval WordDocName as string ) as integer
DISPATCH_OBJ(WordApp)

dhInitialize( TRUE )
dhToggleExceptions( TRUE )
dhCreateObject( "Word.basic", NULL, @WordApp )
dhCallMethod( WordApp, ".AppShow" )
dhCallMethod( WordApp,".fileOpen(%s)",WordDocName)
SAFE_RELEASE( WordApp )
dhUninitialize( TRUE )
searcReplaceinWord=1
end function

'*****************************************
function FBsearcReplaceInWord( byval WordDocName as string , byval GLine as string) as integer export
print"WordDocName=";WordDocName
print"GLine=";GLine

'search and replace parameters

dim FindText as string 
dim MatchCase as byte 
dim MatchWholeWord as byte 
dim MatchWildcards as byte 
dim MatchSoundsLike as byte 
dim MatchAllWordForms as byte 
dim Forward as byte 
dim Wrap as byte '!!!  byte
dim Format as byte 
dim ReplaceWith as string 
dim ReplaceDo as byte 
dim MatchKashida as byte 
dim MatchDiacritics as byte 
dim MatchAlefHamza as byte 
dim MatchControl as byte

dim Parameters as string 

' Gline - string contains all search and replace parameters fields, separated by chr$(149)
'1 field - FindText
'2 field - ReplaceWith
'3 field - Parameters
' Parameters is string contains substrings - MatchCase MatchWholeWord MatchWildcards etc.

'rqFIELD$(Srcstring as string, delimstring as string, fieldNumber as integer)

FindText=rqFIELD$(Gline,chr$(149),1)
print"FindText=";FindText
ReplaceWith=rqFIELD$(Gline,chr$(149),2)
print"ReplaceWith=";ReplaceWith
Parameters=rqFIELD$(Gline,chr$(149),3)
print"Parameters=";Parameters

if instr(Parameters,"MatchCase")>0 then MatchCase=1 else MatchCase=0
if instr(Parameters,"MatchWholeWord")>0 then MatchWholeWord=1 else MatchWholeWord=0
if instr(Parameters,"MatchWildcards")>0 then MatchWildcards=1 else MatchWildcards=0
print"MatchWildcards=";MatchWildcards
if instr(Parameters,"MatchSoundsLike")>0 then MatchSoundsLike=1 else MatchSoundsLike=0
if instr(Parameters,"MatchAllWordForms")>0 then MatchAllWordForms=1 else MatchAllWordForms=0
if instr(Parameters,"Forward")>0 then Forward=1 else Forward=0
if instr(Parameters,"Format")>0 then Format=1 else Format=0
if instr(Parameters,"Replace")>0 then Replace_=1 else Replace_=0
if instr(Parameters,"MatchKashida")>0 then MatchKashida=1 else MatchKashida=0
if instr(Parameters,"MatchDiacritics")>0 then MatchDiacritics=1 else MatchDiacritics=0
if instr(Parameters,"MatchAlefHamza")>0 then MatchAlefHamza=1 else MatchAlefHamza=0
if instr(Parameters,"MatchControl")>0 then MatchControl=1 else MatchControl=0


DISPATCH_OBJ(wdApp)
DISPATCH_OBJ(wdDoc)
DISPATCH_OBJ(wdFont)
DISPATCH_OBJ(wdRange)
DISPATCH_OBJ(wdFind)
dhInitialize(TRUE)

'/* Turn on DispHelper exceptions */
dhToggleExceptions(TRUE)

dhCreateObject("Word.Application", NULL, @wdApp)
dhPutValue(wdApp, ".Visible = %b", TRUE)
dhCallMethod( WdApp,".Documents.Open %s",WordDocName)
dhGetValue("%o", @wdDoc, wdApp, ".ActiveDocument")
dhGetValue("%o", @wdRange, wdDoc, ".Content")
dhGetValue("%o", @wdFind, wdRange, ".Find")

'FindText ="*>"
'MatchCase =0
'MatchWholeWord =0
'MatchWildcards =1
'MatchSoundsLike =0
'MatchAllWordForms =0
Forward =1
Wrap =wdFindContinue
print"Wrap=";Wrap
'Format =0
'ReplaceWith ="666"
ReplaceDo =wdReplaceAll '2
print"ReplaceDo=";ReplaceDo
'MatchKashida =0
'MatchDiacritics=0 
'MatchAlefHamza =0
'MatchControl=0

'dhCallMethod( wdFind,".Execute %s,%m,%m,%m,%m,%m,%m,%m,%m,%s,%d,%m,%m,%m,%m" ,_
'                               1  2  3  4  5  6  7  8  9  0  1  2  3  4  5                     
dhCallMethod( wdFind,".Execute %s,%b,%b,%b,%b,%b,%b,%d,%b,%s,%d,%b,%b,%b,%b" ,_
FindText,_ '1
MatchCase,_ '2
MatchWholeWord,_ '3
MatchWildcards,_ '4
MatchSoundsLike,_ '5 
MatchAllWordForms,_ '6
Forward ,_ '7
Wrap ,_ '8
Format ,_'9
ReplaceWith,_ '0
ReplaceDo ,_ '1
MatchKashida,_ '2
MatchDiacritics,_ '3
MatchAlefHamza,_ '4
MatchControl,_ '5
)

cleanup:
'/* Turn off exceptions for cleanup */
dhToggleExceptions(FALSE)'
'/* wdApp.ActiveDocument.Saved = True */
'/* This prevents the user being prompted when word is closed. */
dhPutValue(wdApp, ".ActiveDocument.Saved = %b", TRUE)'
'/* wdApp.Quit() */
'dhCallMethod(wdApp, ".Quit")'
'/* Release objects we obtained */
SAFE_RELEASE(wdDoc)'
SAFE_RELEASE(wdApp)'
'/* Takes care of uninitializing COM and avoids memory leaks */
dhUninitialize(TRUE)'
'return 0'
FBsearcReplaceInWord=1
end function


'WordSample1
'FBsearcReplaceInWord ("C:\BAS\freebasic\FreeBasic16\disphelper\2lpecs.doc","*>"+chr$(149)+"666"+chr$(149)+" MatchWildcards ")
'OpenWordDocVBA ("C:\BAS\freebasic\FreeBasic16\disphelper\2lpecs.doc")
